/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

#ifndef _amiga_a2091_h
#define _amiga_a2091_h

#define PHYS_A2091_DMAC 0xe90000  /* This should be autoconfig'ed */
struct a2091_dmac_t {
  u_short _____________pad0[32];	/* 00 */
  u_short int_status;			/* 40 */ /* ISTR (RO) */
  u_short control;			/* 42 */ /* CNTR (RW) */
  u_short _____________pad1[30];	/* 44 */
  u_long  word_Xfer_count;		/* 80 */ /* WTC  (RW) */
  void    *DMA_address;			/* 84 */ /* SAC  (WO) */
  void	  *dest_address;		/* 88 */ /* DAC	 (WO) */
  u_short _____________pad2[1];		/* 8c */
  u_short DACK_width;			/* 8e */ /* DAWR (RW) */
  u_char  _____________pad3;		/* 90 */
  u_char  wd_address;			/* 91 */
  u_char  _____________pad4;		/* 92 */
  u_char  wd_data;			/* 93 */
  u_short _____________pad5[38];	/* 94 */
  u_short start_DMA;			/* strobe */	/* e0 */
  u_short stop_DMA;			/* strobe */	/* e2 */
  u_short clear_ints;			/* strobe */	/* e4 */
  u_short reset_autoconfig;		/* e6 */  /* RACF */
  u_short flush_DMA;			/* strobe */	/* e8 */
};

/* bits in `int_status' ITSR */
#define INTF			(1<<7)	/* Any intr */
#define P_INT			(1<<6)  /* Xtr intr */
#define E_INT			(1<<5)  /* Done DMA */
#define INT_P			(1<<4)  /* Intr pending */
#define UE_INT			(1<<3)  /* FIFO Underrun */
#define OE_INT			(1<<2)  /* FIFO Overrun */
#define FF_FLG			(1<<1)  /* FIFO full */
#define FE_FLG			(1<<0)  /* FIFO empty */

#define A2091_DMAC_DMA_IDLE	(1<<5)
#define A2091_DMAC_INT_PENDING	(1<<4)

/* settings in `control' CNTR */
#define TCEB			(1<<7) /* Enable terminal count */
#define PREST			(1<<6) /* Peripheral reset */
#define PDMD			(1<<5) /* set hi for SCSI */
#define IEB			(1<<4) /* Enable IRQ */
#define DDIR			(1<<3) /* 1 = WR, 0 = RD */
#define DMAMD			(1<<2) /* 1 = MEM-MEM, 0 = I/O */
#define NESTY			(1<<1) /* DMA Nasty mode bit */
#define XT_EOP			(1<<0) /* XT stuff */

#define A2091_DMAC_DIR_READ	((1<<4) | (1<<5))
#define A2091_DMAC_DIR_WRITE	((1<<4) | (1<<4) | (1<<5))

/* used value for `DACK_width' */
#define A2091_DMAC_WIDTH	3

#ifdef KERNEL
#define a2091_dmac (*((volatile struct a2091_dmac_t *)VM_A2091_DMAC))
#define phys_a2091_dmac (*((volatile struct a2091_dmac_t *)PHYS_A2091_DMAC))
#define A2091_SCSI_ADDR (&a2091_dmac._____________pad3)
#define PHYS_A2091_SCSI_ADDR (&phys_a2091_dmac._____________pad3)
#endif


#endif /* _amiga_a2091_h */

